import java.net.URL;
import java.util.*;
import java.sql.*;
// import com.internetcds.jdbc.tds.*;
import java.lang.Thread;
import java.math.BigDecimal;


public class t0036
{
   public static void main(String args[])
      throws java.sql.SQLException, java.lang.ClassNotFoundException,
      java.lang.IllegalAccessException, java.lang.InstantiationException,
      java.lang.InterruptedException
   {
      System.out.println("Test a multiple drop table errors in a row");

      String     table;
      boolean    passed       = true;        
      Statement  stmt         = null;
      int        i            = 0;  
      final int  numberToTest = 5;


      Connection cx = Common.getConnection();

      stmt = cx.createStatement();

      i = 0;
      while(passed && (++i)<=numberToTest)
      {
         table = "t0036_do_not_create_" + i;
         // System.out.println("Dropping " + table);
         try
         {
            stmt.executeUpdate("drop table " + table);
            System.out.println("Expected error message when dropping table "
                               + table);
            passed = false;
         }
         catch (SQLException e)
         {
            if (! (e.getMessage().startsWith("Cannot drop the table '"+table+"', because it does")))
            {
               throw e;
            }
            // System.out.println(e.getMessage());
         }
      }
      

      System.out.println("\n" + (passed ? "Passed" : "Failed") 
                         + " t0036.\n");
      System.exit(passed ? 0 : 1);

   }
}

