
import java.sql.*;
import java.io.*;


/**
 * test retrieving from a closed result set
 *
 */
public class t0044
{
   static public void main(String args[])
      throws SQLException, java.lang.ClassNotFoundException, IOException
   {
      boolean   passed = true;


      System.out.println("Starting test t0044-  " +
                         " Try to retrieve from a closed ResultSet");



      // open the database

      Connection  cx       = Common.getConnection();
      Statement   stmt     = cx.createStatement();

    
      ResultSet  rs1 = stmt.executeQuery("select 1");

      rs1.close();

      try
      {
         if (rs1.next())
         {
            System.out.println("Got a result.  Shouldn't have");
            passed = false;
         }
      }
      catch (SQLException e)
      {
         if (e.getMessage().startsWith("result set is cl"))
         {
            passed = true;
         }
         else
         {
            System.out.println("Unexpected exception\n" 
                               + e.getMessage());
            passed = false;
         }
      }

                

      System.out.println("\n" + (passed ? "Passed" : "Failed") 
                         + " t0044.\n");
      System.exit(passed ? 0 : 1);
   }
}

